<template>
  <v-card flat>
    <v-card-text class="pt-0 pb-0">
      <v-autocomplete
          flat
          clearable
          dense
          v-model="group"
          :items="items"
          :filter="() => true"
          :loading="isLoading"
          :search-input.sync="search"
          :no-data-text="meteredSearch && meteredSearch.length > 0 && !isLoading ? 'No results' : ''"
          hide-details="auto"
          item-text="name"
          item-value="id"
          label="Search by group name, path or ID"
          return-object
      >
      <template v-slot:selection="data">
          <v-list-item-content v-if="data.item.name">
            <v-list-item-title v-html="data.item.name"></v-list-item-title>
            <v-list-item-subtitle class="font-italic">{{ data.item.full_name === data.item.name ? 'Top Level Group' : data.item.full_name }}</v-list-item-subtitle>
          </v-list-item-content>
        </template>
        <template v-slot:item="data">
          <template>
            <v-list-item-content v-if="data.item.name">
              <v-list-item-title v-html="data.item.name"></v-list-item-title>
              <v-list-item-subtitle class="font-italic">{{ data.item.full_name === data.item.name ? 'Top Level Group' : data.item.full_name }}</v-list-item-subtitle>
            </v-list-item-content>
          </template>
        </template>
      </v-autocomplete>
    </v-card-text>
  </v-card>
</template>

<script lang="ts">
import { Component, Mixins, Prop, PropSync, Watch } from 'vue-property-decorator'
import log from 'loglevel'
import ApiAccess from '@/mixins/apiAccess'

@Component
export default class GroupSelector extends Mixins(ApiAccess) {
    @Prop({ default: false })
    topLevelOnly!:boolean

    @PropSync('selectedGroup')
    group: any

    descriptionLimit = 120
    count = 0
    entries:any[] = []
    isLoading = false
    search = ''
    meteredSearch = ''
    timeout: any
    items: any[] = []
    shouldSetInitialSection = true

    activated (): void {
      if (!this.group) {
        this.findGroups()
      }
    }

    @Watch('search')
    meteredUpdateSearch (): void {
      this.shouldSetInitialSection = false
      if (this.search === '') {
        this.items = []
      }
      clearTimeout(this.timeout)
      this.timeout = setTimeout(() => {
        this.meteredSearch = this.search
      }, 500)
    }

    @Watch('entries')
    loadItems (): void {
      this.items = this.entries.map(entry => {
        try {
          const fullName = entry.full_name.length > this.descriptionLimit
            ? entry.full_name.slice(0, this.descriptionLimit) + '...'
            : entry.full_name

          return Object.assign({}, entry, { full_name: fullName })
        } catch (err) {
          log.error(err)
          log.error(entry)
        }
      })
    }

    @Watch('meteredSearch')
    async findGroups (): Promise<void> {
      const searchIsNumber = /^\d+$/.test(this.search)
      if (this.isLoading || this.search == null || this.group?.name === this.search ||
        (this.search?.length < 3 && !searchIsNumber)) {
        return
      }
      this.isLoading = true
      const groups = (this.getRestAPI().Groups as any)
      if (this.isReference()) {
        groups.show(this.getReference()).then((result: any) => {
          this.entries = [...(Array.isArray(result) ? result : [result])]
        }).finally(() => { this.isLoading = false })
      } else {
        let results: any[] = []
        if (searchIsNumber) {
          await groups.show(this.search).then((result: any) => {
            results = results.concat([...(Array.isArray(result) ? result : [result])])
          }).catch((err: any) => {
            if (err.response?.status !== 404) {
              console.log(err)
            }
          })
        }
        const skipGroupIDs = results.map(entry => entry.id)

        groups.search(this.search, { maxPages: 2, top_level_only: this.topLevelOnly, order_by: 'similarity', skip_groups: skipGroupIDs })
          .then((result: any) => {
            const arrayResult = Array.isArray(result) ? result : [result]
            this.entries = results.concat(arrayResult)
          })
          .finally(() => { this.isLoading = false })
      }
    }

    isReference (): boolean {
      return this.search?.indexOf('/') >= 0
    }

    getReference (): string {
      return this.search.trim().replace(this.getHost(), '').replace('/^//g', '').replace('///g', '%2f')
    }
    // }
}

</script>
